unit dtmf;

interface

uses
  Classes, SysUtils, MMSYSTEM;

type
  { TDTMFPlay }
  TDTMF = record
  public
    class procedure Play(const aPhoneNumber: string; aMinimumPause: Integer = 0); static;
  end;

implementation

{ TDTMF }

class procedure TDTMF.Play(const aPhoneNumber: string; aMinimumPause: Integer = 0);
var
  C: Char;
  RS: TResourceStream;
  procedure PlayWav(aC: Char; aMinimumPause: Integer);
  var
    RS: TResourceStream;
    ResName: String;
    dC: Char;
  begin
    // Generate Resource Name
    case C of
      '#': dC := 'N'; // Number
      '*': dC := 'S'; // Asterisk
    else
      dC := aC;
    end;
    ResName := Format('DTMF_%s', [dC]);
    // Play DTMF 100ms
    RS :=TResourceStream.Create(hInstance, ResName, 'WAV');
    try
      PlaySound(RS.Memory, 0, SND_MEMORY or SND_SYNC);
    finally
      RS.Free;
    end;
    // Sleep <aMinimumPause>ms (Minimum Pause)
    Sleep(aMinimumPause);
  end;
begin
  // Play Null
{
  PlayWav('_', 0);
}
  // Play DTMF
  for C in aPhoneNumber do
    if CharInSet(C, ['#', '*', '0'..'9', 'A'..'Z']) then
      PlayWav(C, aMinimumPause);
end;

end.
